import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Writer;
import java.net.URL;
import java.net.URLConnection;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

public class Browser // Gwna klasa programu - Browser - tutaj zawiera si cay kod programu.
{
	String line; // Deklaracja zmiennej line typu string, oznaczajcej konkretn lini (wiersz) otwieranego przez uytkownika pliku.
	String id; // Deklaracja zmiennej id, bdcej identyfikatorem genu.
	String geneName; // Deklaracja zmiennej geneName oznaczajcej nazw genu.
	int index; // Deklaracja zmiennej index typu int oznaczajcej indeks danej linii.
	// Wszystkie te zmienne deklarowane s wewntrz klasy Browser, jednak poza istniejcymi metodami klasy. Umoliwia to dostp metod do zmiennych.

	public Browser() {} // Tworzenie pustego konstruktora (w konstruktorze umieszczane s operacje niezbdne do zainicjalizowania klasy).
	
	public Browser(String fileName) // Metoda Browser() pobierajca nazw wybranego przez uywtkonika pliku - fileName.
	{
		try // Obsuga wyjtkw.
		{
			BufferedReader input = new BufferedReader(new FileReader(fileName)); // Tworzenie obiektu klasy BufferedReader (bufrowanie pliku). 
			// Jako argument przyjmowany jest obiekt fileName nalecy do klasy FileReader.
			try // Obsuga kolejnych wyjtkw.
			{
				while ((line = input.readLine()) != null) // Dopki odczytywane z pliku linie nie s puste wykonuj poniszy kod:
				{
					index = line.indexOf("\"", 1); // Odczytywany jest auch znakw.
					id = line.substring(1, index); // Wyciganie z okrelonego acucha fragmentu tekstu (metoda substring()). 
					index = line.indexOf("\"", index + 1);
					geneName = line.substring(index + 1, line.indexOf("\"", index + 1));
				}
			} 
			finally 
			{
				input.close(); // Po zakoczeniu powyszych dziaa nastpuje zamknicie.
			}
		} 
		catch (IOException ex) // Wyjtek.
		{
			ex.printStackTrace(); // Wypisywanie w konsuli rodzajw bdw
		}
	}
	
	
	// czenie z baz BioMart www.biomart.org - metoda displayBioMartResults().
	public List<String[]> displayBioMartResults(String geneName, String latinName, String sym, String affy)
	// Funkcja zwraca list elementw typu string. Pobiera z kolei cztery wartoci: 
	// nazw genu (geneName, acisk nazw organizmu (latinName), symbol organizmu (sym), nazw mikromacierzy (affy).
	{
		String[] martResults = new String[4]; // Tworzona jest tablica czteroelementowa.
		List<String[]> linkedMartResults = new LinkedList<String[]>(); // Tworzenie listy typu LinkedList().

		// Tworzenie zapyta do bazy BioMart
		String cd = "http://www.biomart.org/biomart/martview?VIRTUALSCHEMANAME=default&"
				+ "ATTRIBUTES=" + latinName + "_gene_ensembl.default.feature_page.ensembl_gene_id|" //Ensembl ID
				+ latinName + "_gene_ensembl.default.feature_page."+sym+"_id|" //HGNC ID
				+ latinName + "_gene_ensembl.default.feature_page."+sym+"_symbol|" // symbol genu
				+ latinName + "_gene_ensembl.default.feature_page.uniprot_swissprot|" // UniProt/SwissProt ID
				+ latinName + "_gene_ensembl.default.feature_page."+affy+"&" // symbol Affymetrixa (tylko dla hsapiens)
				+ "FILTERS=" + latinName + "_gene_ensembl.default.filters."+sym+"_symbol.\"" // filtracja po symbolu HGNC
				+ geneName;
		
		try 
		{
			URL bioMart = new URL(cd); // Tworzenie obiektu klasy URL.
			URLConnection connection = bioMart.openConnection(); // Nawizywanie poczenia z Internetem.
			BufferedReader in = new BufferedReader(new InputStreamReader(connection.getInputStream())); // Odczyt wynikw.

			String inputLine;

			while ((inputLine = in.readLine()) != null) // Dopki odczytywane linie z strony internetowej nie s puste wykonuj:
			{	
				if (inputLine.indexOf("mart_tr1") != -1) // Jeeli linia rozpoczyna si od mart_tr1:
				{	
					for (int i = 0; i < 6; i++) // Wykonuj ptl odczytujc informacje zawarte w tym fragmencie strony zapisanej w HTML.
						in.readLine();
					
					while (!(inputLine = in.readLine()).equals("</table>")) // Dopki czytana linia nie jest rwna znakowi </table> wykonuj kod:
					// (Znak ten oznacza zakoczenie otrzymanych informacji na temat danego genu).
					{ 
					//	System.out.println(inputLine); <- tym sposobem mona sprawdzi struktur otrzymanych wynikw.
						if (inputLine.indexOf("mart_tr1") != -1) 
						{
							String[] bioMartValue = new String[5]; // Tworzenie nowej tablicy jednowymiarowej, do ktrej bd zapisywane konkretne wyniki pobrane z bazy.
							
							if (latinName=="hsapiens") // Jeeli uytkownik wybra organizm Human wwczas stosuje si poniszy zapis wynikw do tablicy bioMartValue.
							{
								inputLine = in.readLine(); // Odczytywana jest pierwsza linia kodu HTML.
								bioMartValue[1] = inputLine.substring(inputLine.indexOf("nk\">") + 4, inputLine.indexOf("</a>"));
								// Do danejkomrki wektora bioMartValue przypisywany jest cig znakw znajdujcy si w wyniku HTML pomidzy znakami "nk\">" a "<\a>".
								
								inputLine = in.readLine(); // druga linia
								bioMartValue[3] = inputLine.substring(inputLine.indexOf("d\">") + 3, inputLine.indexOf("</td>"));
							
								inputLine = in.readLine(); // trzecia linia
								bioMartValue[4] = inputLine.substring(inputLine.indexOf("nk\">") + 4, inputLine.indexOf("</a>"));

								inputLine = in.readLine(); // czwarta linia
								bioMartValue[0] = inputLine.substring(inputLine.indexOf("nk\">") + 4, inputLine.indexOf("</a>"));
							
								inputLine = in.readLine(); // pita linia
								bioMartValue[2] = inputLine.substring(inputLine.indexOf("nk\">") + 4, inputLine.indexOf("</a>"));
							}
							
							if (latinName=="mmusculus") // Jeeli uytkownik wybra organizm Mouse wykonuj analogicznie do poprzedniego kod:
							{
								inputLine = in.readLine(); // pierwsza linia
								bioMartValue[1] = inputLine.substring(inputLine.indexOf("nk\">") + 4, inputLine.indexOf("</a>"));
								
								inputLine = in.readLine(); // druga linia
								bioMartValue[0] = inputLine.substring(inputLine.indexOf("nk\">") + 4, inputLine.indexOf("</a>"));
							
								inputLine = in.readLine(); // trzecia linia
								bioMartValue[2] = inputLine.substring(inputLine.indexOf("nk\">") + 4, inputLine.indexOf("</a>"));

								inputLine = in.readLine(); // czwarta linia
								bioMartValue[3] = inputLine.substring(inputLine.indexOf("d\">") + 3, inputLine.indexOf("</td>"));
							
								inputLine = in.readLine(); // pita linia
								bioMartValue[4] = inputLine.substring(inputLine.indexOf("nk\">") + 4, inputLine.indexOf("</a>"));
							}
						
							martResults = new String[4]; // Tworzenie nowej tablicy czteroelementowej.

							martResults[0] = bioMartValue[0]; // Zapis otrzymanych danych do konkretnych indekw tablicy martResults.
							martResults[1] = bioMartValue[1];
							martResults[2] = bioMartValue[2]; 
							martResults[3] = bioMartValue[3]; 
							
							linkedMartResults.add(martResults);  // Dodawanie danych do listy (tabeli).
						}
					}
				} 
				else {}
			}
			in.close(); // Zamknicie pobierania i zapisu.
			return linkedMartResults; // Zwracana jets lista otrzymanych wynikw.
		} 
		catch (Exception ex) 
		{
			ex.printStackTrace();
		}
		return linkedMartResults;
	}

	
	// Porwnywanie wierszy tablicy - metoda compareRowArrays.
	public static boolean compareRowArrays(String[] rowA, String[] rowB) 
	// Metoda zwraca wartoci logiczne, a przyjmuje tablic wierszy rowA oraz tablic wierszy rowB.
	{
		if (rowA.length != rowB.length) return false; // Jeeli dugo wiersza A jest rna od dugoci wiersza B, zwracana jest warto false.
		
		String rowAA = null; // Tworzenie nowych zmiennych dla tablic rowA i rowB. 
		String rowBB = null;
		
		for (int i = 0; i < rowA.length; i++) // Pta od 1 do dugoci wiersza rowA (jeeli wiersz rowA i rowB maj te same dugoci).
		{
			rowAA = rowA[i]; // Do zadeklarowanych wczeniej zmiennych zapisywana jest wartoc znajdujca si w wierszu rowA o indeksie i.
			rowBB = rowB[i];

			if (!rowAA.equals(rowBB)) return false; // Jeeli dane znajdujce si w rowAA s rne od danych w rowBB zwracaj false.
		}
		return true; // W innym przypadku zwracana jest warto true.
	}

	// Jeeli ktry z wynikw w danym wierszu jest rny od wyniku w wierszu kolejnym, wwczas wyniki s unikatowe, nie powtarzaj si i mog zosta zapisane do pliku).
	// Tworzenie listy usuwajcej niepotrzebne elementy (powtarzajce si komrki)
	public static List<String[]> reduceUselessShit(List<String[]> p) // p = parametr nalecy do listy - jest przyjmowany. 
	// Funckcja zwraca list wynikw.
	{
		if (p.size() < 2) return p; // Jeeli wielko parametru p jest mniejsza od 2 (wynosi 1), wwczas zwracany jest ten parametr.

		List<String[]> result = new LinkedList<String[]>();

		String[] tmp = null;
		boolean res = false;

		result.add(p.get(0)); // Dodawanie do nowoutworzonej listy rezultatw result danego parametu.

		for (int i = 1; i < p.size(); i++) // W ptli dokonywane jest porwnanie danych wierszy z wywoaniem funkcji compareRowArrays().
		{
			tmp = p.get(i);
			res = false;

			for (String[] tmpOk : result) // Do stworzonej tablicy stringw tmpOk przypisywane s wartoci listy result.
			{
				if (compareRowArrays(tmp, tmpOk)) // Owierana jest funkcja compareRowArrays, do ktrej przesyane s dane tmp i tmpOk. 
				// Kolejno s one odczytywane w funkcji jako rowA i rowB. 
				{
					res = true; // Wynik rezultatu: jeeli rezultatem dziaania funkcji compareRowArrays() jest watoo true - 
					// zakocz dziaanie. Dalszy kod nie jest wykonywany.
					break;
				}
			}
			
			if (!res) // Jeeli rezultat jest false - tzn. przechodzi si do nowego wiersza.
			{
				result.add(tmp); // Taki wynik dodawany jest do tablicy result. 
			}
		}
		return result; // Po wykonaniu funkcji zwracana jest lista stringw o nazwie result. 
	}

	
	// Gwna cz programu - metoda main() - moliwe jest uruchomienie tylko tej klasy, ktra zawiera metod main(). 
	// Metoda ta rozpoczyna program.
	public static void main(String[] args) throws IOException // Metoda obsuguje wyjtki 
	// (IOException - bd java.io.IOException pojawia si wwczas, gdy nie jest moliwe nawizanie poczenia z Internetem).
	{
		System.out.println("Witaj w programie GeneBrowser!\n"); // Polecenie wypisuje na ekran konsoli dane podane w nawiasie.
		
		// Wybr przez uytkownika jednego z dwch organizmw, o ktrych informacje mog zosta pobrane z bazy Biomart za pomoc plikw anotacji GO.
	    Object[] poss = {"Homo sapiens (Human)", "Mus musculus (Mouse)"}; // Stworzenie obiektu bdcego tablic dwch elementw przedstawionych w nawsiasie klamrowym. 
	    // Nazwa obiektu to poss (od sowa pozycja).
	    String initSelection = "Homo sapiens (Human)"; // Okrelenie, ktra z dwch opcji inicjuje selekcj organizmw (w wyborze w oknie dialogowym).
	    Object selection = JOptionPane.showInputDialog(null, "Wybierz nazw organizmu", "Nazwa organizmu", JOptionPane.QUESTION_MESSAGE, null, poss, initSelection); 
	    // Stworzenie okna dialogowego z prob do uytkownika o podanie nazwy organizmu. "null" oznacza rodzica (komponent bazowy dla danego okna), 
	    // drugi parametr to wiadomo umieszczana w oknie dialogowym, trzeci to acuch znakw wywietlany w pasku tytulowm okna. 
	    // Kolejny parametr to typ wiadomoci (tutaj widmo pytajca), ikona wywietlana zamiast jednej ze standardowych ikon, poss to tablica wartoci
	    // wywietlanych w licie kombinowanej. Ostatni z parametrw to domylna opcja prezentowania zapyta uytkownikowi programu.
	    System.out.println(selection);
	    
		if(selection == null) // Jeeli uytkownik zamknie okno dialogowe uywajc przycisku "Cancel" wwczas pojawi si okno dialogowe oznaczajce bd.
		// Program po pojawieniu si okna i zaakceptowaniu wiadomoci przez uytkownika zakoczy dziaanie. 
		{
			JOptionPane.showMessageDialog(null, "Zakoczenie programu!", "Error", JOptionPane.ERROR_MESSAGE); // Okno dialogowe - typ wiadmoci o bdzie/
			System.exit(0); // Zamknicie systemu spowodowane bdem.
		}
		// Jeeli nie pojawi si bd, wwczas program wykonywany jest z pominiciem fragmentu kodu odpowiadajcego za przerwanie programu w przypadku wystpienia bdu.
	    
		String sym = ""; // Inicjalizacja zmiennej sym oznaczajcej symbol genu.
	    String affy = ""; // Inicjalizacja zmiennej affy oznaczajcej rodzaj mikromacierzy DNA firmy Affymetrix dla danego organizmu.
		String latinName = ""; // Inicjalizacja zmiennej latinName oznaczajacej acisk nazw orgaznimu wybranego przez uytkownika.
	    
	    if (selection == "Homo sapiens (Human)") // Jeeli uytkownik wybierze organizm Human, wwczas wykonuje si poniszy fragment skryptu.
	    {
	    	System.out.println("Czlowiek"); 
	    	sym = "hgnc"; // Do zmiennej sym przypisywana jest warto string "hgnc" (acuch znakw).
	    	latinName = "hsapiens"; // Do zmiennej latinName przypisywana jest nazwa aciska organizmu (pierwsza litera pierwszego czonu i drugi czon w caoci).
	    	affy = "affy_hg_u133_plus_2"; // Do zmiennej affy przypisywany jest cig znakw bdcy nazw mikromacierzy DNA dla danego organizmu.
	    }  
	    if (selection == "Mus musculus (Mouse)") // To samo co powyej wykonuje si, gdy uytkownik wybierze organizm Mouse. 
	    {
	    	System.out.println("Mysz");
	    	sym = "mgi";
	    	latinName = "mmusculus";
	    	affy = "affy_mogene_1_0_st_v1";
	    }
	
		// Nastpnie pojawia si okno dialogowe z wiadomoci:
		JOptionPane.showMessageDialog(null, "Za chwil pojawi si okno wyboru pliku. \n Wybierz plik anotacji GO.");
	    
		// Czytanie pliku z dysku nastpuje po wyborze przez uytkownika nazwy orgaznimu. 
		JFileChooser wybor = new JFileChooser(); // Tworzony jest obiekt wybor nalecy do klasy JFileChooser.
		// Klasa ta odpowiada za okno dialogowe umoliwiajce wybr pliku z dysku oraz cieki dostpu do tego pliku.
		wybor.setCurrentDirectory(new File(".")); // Ustawaiana jest jako domyla aktualna cieka dostpu, w ktrej znajduje si plik z programem.
		int wynik = wybor.showOpenDialog(null); // Deklaracja zmiennej wynik typu integer. Otwierane jest okno dialogowe z moliwoci wyboru 
		// i otwarcia pliku z anotacjami GO. Przycisk "Cancel" ma warto domyln null (nawias).
		
		if(wynik == JFileChooser.CANCEL_OPTION) // Jeeli uytkownik zamknie powysze okno dialogowe, wwczas pojawia si bd 
		// i nastpuje zamknicie systemu.
		{
			JOptionPane.showMessageDialog(null, "Zakoczenie programu!", "Error", JOptionPane.ERROR_MESSAGE);
			System.exit(0);
		}
		
		String name = wybor.getSelectedFile().getPath(); // Deklaracja zmiennej name typu string. 
		// Otwierany jest plik o podanej nazwie i ciezce dostpu.
		FileReader fil = new FileReader(name); // Czytanie pliku z utworzeniem nowej zmiennej fil nalecej do klasy File. 
		BufferedReader buff = new BufferedReader(fil); // Utworzenie zmiennej buff nalecej do klasy BufferedReader buforujcej plik 
		// i przyjmujcej zmienn fil.
		String one; // Inicjalizacja zmiennej one, ktra zostanie wykorzystana w poniszym kodzie jako zmienna pomocna przy wyszukiwaniu unikatowych symboli genw.
		Set<String> inFile = new TreeSet<String>(); // Deklaracja wyboru poszczeglnych genw. Klasa TreeSet oznacza, e geny wyszukane w otwartym wczeniej pliku
		// bd przesyane do bazy BioMart w kolejnoci lafabetycznej, a nie w kolejnoci, w jakiej rozmieszczone s w pliku.
		String before = ""; // Inicjalizacja zmiennej before typu string, ktra okrela, jakie symbole genw znajduj si przed symbolem aktualnie analizowanym.

		while ((one = buff.readLine()) != null) // Dopki czytane linie nie s puste wykonuje si kod zapisany w nawiasach klamrowych.
		{ 
			if (one.charAt(0) != 'U') continue; // Jeeli dane linijki (wiersze pliku) nie rozpoczynj si od znaku "U: wwczas program przechodzi do nastpnej linijki.
			// Metoda charAt zwraca okrelony znak, na ktry wskazuje index. 
			String[] parts = one.trim().split("\t"); // Tworzenie zmiennej parts bdcej tablic danych typu string. 
			// Funkcja trim() pozwala na usunicie biaych znakw z koca i z pocztku pobramych acuchw znakw.
			// Funkcja split() rozdziela acuch znakw wedug okrelonego separatora (tutaj: tabulator).
			
			if (!parts[2].equals(before)) // Jeeli zawarto kolejnego z wierszy jest rna od poprzedniego wwczas taka zawato zostaje dodana do tablicy 
			// (zapisywane s tylko unikalne, niepowtarzajace si zawartoci - symbole genw).
			{
				inFile.add(parts[2]);
				before = parts[2];
			}
		}
		fil.close(); // Zamykanie pliku z danymi symbolami genw.
		
		int geneCounter = inFile.size(); // Deklaracja zmiennej geneCounter obliczajcej ile w pliku wystpuje genw 
		// (rozmiar pliku, liczba wierszy, jest otrzymywana za pomoc wykorzystania funkcji size()).
		boolean ok = false; // Deklaracja zmiennej typu logicznego - zmienna ok ma domyln warto false.
		
		System.out.println("Znaleziono :" + geneCounter + " genw.");
		
		String how = ""; // Inicjalizacja zmiennej how wykorzystywanej przy wpisywaniu przez uytkownika liczby genw.
		how = JOptionPane.showInputDialog(null,"Ile pierwszych genw z pliku chcesz przetestowa?\n Jeeli wpiszesz 0 ozncza to, \n"
				+ "e wybierasz wszystkie dane z pliku.\nMaksymalnie moesz wybra 20000 genw.", "Liczba testowanych genw");
		// W powyszym fragmencie kodu do zmiennej how przypisywany jest wybr uytwkonika. W tym miejscu pojawia si okno dialogowe 
		// pozwalajce na wybr liczby genw do przetestowania. 
		
		if (how == null) // Jeeli uytkownik zamknie powysze okno przyciskiem "Cancel" nastpuje zamknicie programu.
		{
			JOptionPane.showMessageDialog(null, "Zakoczenie programu!", "Error", JOptionPane.ERROR_MESSAGE);
			System.exit(0);
		}
		else if (how.length()<1) // Zamknicie programu nastpuje rwnie wwczas, gdy uytkownik nie wpisze w polu tekstownym adnej wartoci.
		{
			JOptionPane.showMessageDialog(null, "Zakoczenie programu!", "Error", JOptionPane.ERROR_MESSAGE);
			System.exit(0);
		}
		
		int i = Integer.parseInt(how); // Inicjalizacja zmiennej i - zmienna how typu string jest konwertowana na zmienn typu integer.
		int z = 0; // Inicjalizacja zmiennej z z pocztkow wartoci rwn 0.

		if (i >= 1 & i <= 20000) // Jeeli uytkownik wpisze do podanego powyej okna dialogowego liczb z podanego obok przedziaau,
		// wwczas do zmiennej i przypisywana jest warto, jak uytkownik wpisa. 
		{
			z = i;
		}
		if (i == 0) // Jeeli uytkownik wpisze 0 wwczas do zmiennej z przypisywana jest wielko caego pliku (liczba wszystkich genw znajdujcych si w pliku).
		{
			z = inFile.size();
		}

		geneCounter = z; // Do wczeniej utworzonej zmiennej geneCounter przypisywany jest wynik z. 
		
		// Nastpnie pojawia si okno dialogowe z wiadomoci:
		JOptionPane.showMessageDialog(null, "Za chwil pojawi si okno wyboru pliku,\n do ktrego naley zapisa otrzymane informacje." +
				"\n Podaj nazw tego pliku oraz okrel ciek dostpu do niego."); 
		
		String fileName = ""; // Tworzona zmienna fileName typu string, oznaczajca nazw pliku do zapisu.
		JFileChooser wybor2 = new JFileChooser(); // Tworzone okno dialogowe z wyborem pliku i cieki dostpu (analogiczne do poprzedniego okna wyboru pliku).
		wybor2.setCurrentDirectory(new File("."));
		int wynik2 = wybor2.showSaveDialog(null);
		fileName = wybor2.getSelectedFile().getPath();
		
		if(wynik2 == JFileChooser.CANCEL_OPTION)
		{
			JOptionPane.showMessageDialog(null, "Zakoczenie programu!", "Error", JOptionPane.ERROR_MESSAGE);
			System.exit(0);
		}

		int hgncEnsemblSwissAffyChoice = 0; // Inicjalizacja zmiennej hgncEnsemblSwissAffyChoice. Domyln wartoci zmiennej jest tutaj warto 0 (wybr wszystkich genw).
		
		// Teraz do zmiennej how typu string przypisywany jest wynik dziaania okna dialogowego przedstawionego poniej.
		how = JOptionPane.showInputDialog(null, "Ktre z otrzymanych danych w wyniku wyszukiwania\n"
				+ "zapisa do pliku?\n"
				+ "0 - Wszystko\n"
				+ "1 - ENSEMBL ID\n"
				+ "2 - ID GENU\n"
				+ "3 - UniProt/SwissProt ID\n"
				+ "4 - Symbol Affymetrix", "0");
		// Uytkownik moe wybra, jakie informacje o genach chce uzyska i zapisa do plikw.
		
		// Obsuga wyjtkw. Program konwertuje zmienn how na typ integer i przypisuje do zmiennej hgncEnsemblSwissAffyChoice.
		try 
		{
			hgncEnsemblSwissAffyChoice =  Integer.parseInt(how);
		} 
		catch (Exception ex) 
		{
			hgncEnsemblSwissAffyChoice = 0; // Jeeli otzrymujemy bd, wwczas program wykonuje si dalej z wartoci domyln rwn 0.
		}

		File[] files = new File[4]; // Tworzenie tablicy zawierajcej 4 elementy - tablica kocowych fragmentw nazw plikw.
		Writer[] outputs = new Writer[4]; // Inicjalizacja zmiennej outputs (Writer[] - klasa abstrakcji) bdcej tablic zapisywanych informajci.
		String[] oNames = new String[] { "_EnsemblID", "_GeneID", "_UniProtSwissProtID", "_SymbolAffymetrixa" }; 
		// Tworzony jest wektor zawierajcy kocowe fragmenty nazw poszczeglnych plikw. 
		String[] preNames = new String[] { "","","","" }; 

		int w = 0;
		boolean[] hgncEnsemblSwissAffyChoices = new boolean[4]; // Tworzenia tablicy zawierajcej wartoci logiczne.
		// Na starcie wszytskie wartoci s typu false.
		
		switch(hgncEnsemblSwissAffyChoice) // Zdarzenia, ktre s wykonywane w zaleznoci od tego, jakiej odpowiedzi udzieli uytkownik
		// na pytanie jakie informacje o genach chce uzyska.
		{
			case 0: // Jeeli uywtkownik wybierze 0 wwczas program tworzy 4 pliki i zapisuje do nich wszystkie cztery odnalezione w bazie Biomart informacje.
			{
				hgncEnsemblSwissAffyChoices[0] = true; // Kolejnym elementom tablicy przypisywane s wwczas wartoci true. 
				hgncEnsemblSwissAffyChoices[1] = true;
				hgncEnsemblSwissAffyChoices[2] = true;
				hgncEnsemblSwissAffyChoices[3] = true;
				
				if (fileName != null) // Jeeli nazwa pliku jest tutaj rna od zera, wwczas wykonywana jest ptla for.
				{
					for (int j = 0; j < 4; j++) 
					{
						files[j] = new File(fileName + oNames[j] + ".txt"); // Tworzone s 4 pliki o rnych nazwach w zalenoci od rodzaju zapisywanych danych.
						// Nazwa pliku skada si z trzech czonw: nazwa podana przez uytkownika, nazwa pliku o danych informacjach o genie, rozszerzenie pliku (.txt).
						outputs[j] = new BufferedWriter(new FileWriter(files[j])); // Zapis wynikw.
					}  
				}
				w = 0; // Warto zmiennej w dla tego przypadku jest rwna 0.
				break; // Koniec case'a.
			} 
			
			case 1: // W tym przypadku tworzony jest plik zawierajcy informacje o EnsemblID.
			{
				hgncEnsemblSwissAffyChoices[0] = true;
				files[0] = new File(fileName + oNames[0] + ".txt");
				outputs[0] = new BufferedWriter(new FileWriter(files[0]));
				w = 1;
				break;
			} 
			
			case 2: // Tworzony jest plik zawierajcy informacje o ID genu.
			{
				hgncEnsemblSwissAffyChoices[1] = true;
				files[1] = new File(fileName + oNames[1] + ".txt");
				outputs[1] = new BufferedWriter(new FileWriter(files[1]));
				w = 2;
				break;
			} 
			
			case 3: // Tworzony jest plik zawierajcy informacje o UniProt/SwissProt ID.
			{
				hgncEnsemblSwissAffyChoices[2] = true;
				files[2] = new File(fileName + oNames[2] + ".txt");
				outputs[2] = new BufferedWriter(new FileWriter(files[2]));
				w = 3;
				break;
			} 
			
			case 4: // W tym przypadku tworzony jest plik zawierajcy informacje o symbolach mikromacierzy Affymetrix.
			{
				hgncEnsemblSwissAffyChoices[3] = true;
				files[3] = new File(fileName + oNames[3] + ".txt");
				outputs[3] = new BufferedWriter(new FileWriter(files[3]));
				w = 4;
				break;
			} 
		}
		
		Browser b = new Browser(); // Inicjalizacja klasy b.
		
		for (String wyraz : inFile) // Zmienna wyraz oznacza nazw poszczeglnych genw 
			//(symbol aktualnie analizowanego genu znajdujcego si w otwieranym na pocztku programu przez uytkownika pliku).
		{
			ok = false; // Zmienna ok jest rwna false (ta bya zadeklarowana we wczeniejszych fragmentach kodu).
			
			if (geneCounter-- == 0) break; // Jeeli liczba genw rwna jest 0 wykonuj poniszy kod.
			
			while (!ok) // Jeeli ok jest rne od zadeklarowanego (tzn. jego warto jest true) wwczas wykonuj:
			{
				try // (try uywa si podczas tworzenia wyjtkw w Javie)
				{
					System.out.println("\nUnikalny symbol genu: " + wyraz + "\nProsze czekac . . . ");
					
					List<String[]> tmp = null; // Tworzona jest lista danych pobranych z bazy BioMart za pomoc metody displayBioMartResults().
					tmp = b.displayBioMartResults(wyraz, latinName, sym, affy); // Do zmiennej tmp przypisywany jest wynik dziaania metody displayBioMartResults().
					tmp = reduceUselessShit(tmp); // Do zmiennej tmp przypisywany jest wynik dziaania metody reduceUselessShit().
					
					if (fileName != null) 
					{
						for (String[] str : tmp) // Ptla, do ktrej pobierane s wartoci tmp (wyniki).
						{
							String empty = ""; // Deklaracja zmiennej empty, ktra bdzie oznaczaa puste wyniki otrzymywane przy pomocy bazy BioMart.
							
							for (int k = 0; k < str.length; k++) // Ptla od 0 do dugoci tablicy str.
							{
								if (hgncEnsemblSwissAffyChoices[k]) // Jeeli istnieje tablica hgncEnsemblSwissAffyChoices o k-elementach to wykonuj:
								{
									if (!str[k].equals(empty) & !str[k].equals(preNames[k])) // Jeeli dane elementy tablicy str rni si od zmiennej empty (pusty acuch),
									// oraz gdy elementy te s rne od utworzonych pustych elementw tablicy preNames, wwczas wykonywany jest kod:
									{
										preNames[k] = str[k]; // Do tablicy preNames przypisywane s wartoci znajdujace si w tablicy str.
										outputs[k].write(str[k] + "\t" + wyraz + "\n"); // Nastpuje zapis danych do pliku w postaci: pobrany wynik z bazy (str), 
										// tabulator bdcy separatorem, nazwa genu pobranego z pliku anotacji GO (zmienna wyraz), separator oznaczajcy przejcie do nowej linii.
									}
								}
							}
						}

					}

					ok = true; // Wwczas warto zmiennej ok rwna jest true.
				}
				catch (Exception ex) {} // Obsuga wyjtkw - brak.
			}
		}

		if (fileName != null) // Jeeli fileName nie jest puste wwczas zamknij zapisywany(e) plik(i).
		{
			if (w==0)
			{
				for (int l = 0; l < 4; l++) 
				{
					outputs[l].close();
				}
			}
			if (w==1)
			{
				outputs[0].close();
			}
			if (w==2)
			{
				outputs[1].close();
			}
			if (w==3)
			{
				outputs[2].close();
			}
			if (w==4)
			{
				outputs[3].close();
			}
		}
		

		System.out.println("\nKoniec\n");
		
		JOptionPane.showMessageDialog(null, "Zakoczenie dziaania programu.", "Koniec", JOptionPane.PLAIN_MESSAGE); // Okno dialogowe oznaczajce zakoczenie dziaania programu.

	}
}